  Virt Viewer News
  ================

11.0: Nov 18, 2021
------------------

  - Minimum libgovirt is now 0.3.7
  - CentOS 7 is no longer a supported build platform
  - Use header bar for oVirt ISO dialog
  - Add change CD button to toolbar for oVirt
  - Support using ISOs in oVirt DATA storage domains
  - Remove clashing -r command line shortcut for 'resize'
    that clashed with existing 'reconnect' shortcut
  - Support modifier-only hotkeys for cursor release
  - Fix smartcard and USB hotkey configuration regression
  - Add USB device reset hotkey support
  - Fix various mixed up GTK actions for hotkeys
  - Release keyboard grab at same time as mouse grab with
    SPICE
  - Fix misc compiler warnings with glib > 2.68
  - Fix creation of window when guest uses multiple
    heads with a single QXL video card
  - Updated translations from weblate
  - Avoid warnings from GTK from overly strict minimum
    desktop width/height rules
  - Update window action sensitivity to fix regression
    causing disabled send key menu items
  - Fix mixed up action / menu state when user cancels
    a quit request
  - Ensure auth dialog credential fields are cleared
  - Fix setting os-id when building RPMs
  - Avoid extra hyphen in build ID strings
  - Explicitly disable spice/ovirt features when invoking
    meson for RPM builds
  - Fix uninitialized variable for keymaps


10.0: Apr 20, 2021
------------------

  - Switch to use Meson for build system instead of autotools
  - Require libvirt >= 1.2.8
  - Redesign UI to use title bar widget instead of menu bar
  - Request use of dark theme by default, if available
  - Don't filter out oVirt DATA storage domains
    for ISO image sharing
  - Add --keymap arg to allow keys to be remapped
  - Display error message if no extension is present
    for screenshot filename
  - Fix misc memory leaks
  - Use nicer error message if not ISOs are available
  - Use more explicit accelerator hint to distinguish
    left and right ctrl/alt keys
  - Report detailed file transfer errors
  - Use standard about diaglog
  - Refresh and improve translations
  - Install appstream data file in preferred location
  - Refresh appstream data file contents
  - Display VM title when listing VMs, if available
  - Display VM description as tooltop, if available
  - Sort VM names when listing
  - Enable ASLR and NX for Windows builds
  - Add --shared arg to request a shared session for VNC
  - Disable all accels when not grabbed in kiosk mode
  - Allow num keypad to be used for zoom changes
  - Disable grab sequence in kiosk mode to prevent escape
  - Allow zoom hotkeys to be set on the command line / vv file
  - Display error message if VNC connection fails
  - Fix warnings about atomics with new GLib
  - Remove use of deprecated GTK APIs
  - Document cursor ungrab sequence in man pages
  - Honour Ctrl-C when auth dialog is active
  - Minor UI tweaks to auth dialog
  - Support VM power control actions with VNC
  - Add --cursor arg to control whether a local pointer is
    rendered with VNC
  - Add --auto-resize arg and menu to control whether to
    resize the remote framebuffer to math local window size
  - Add support for remote framebuffer resize with VNC
  - Handle case sensitivity when parsing accelerator mappings

9.0: May  1, 2020
-----------------

  - Project moved to https://gitlab.com/virt-viewer/virt-viewer
  - Allow toggling shared clipboard in remote-viewer
  - Fix handling when initial spice connection fails
  - Fix check for govirt library
  - Add bash completion of cli args
  - Improve errors in file transfer dialog
  - Fix ovirt foreign menu storage domains query
  - Prefer TLS certs from oVirt instead of CLI
  - Improve USB device cleanup when Ctrl-C is used
  - Remember monitor mappings across restarts
  - Add a default file extension to screenshots
  - Updated translations
  - Fix misc memory leaks

8.0: Mar  1, 2019
-----------------

  - Fix warnings with latest GCC versions
  - More strictly filter out non-ISO images in ovirt menu
  - Require libgovirt >= 0.3.3
  - Require librest >= 0.8
  - Support UNIX and TLS URI schemes for spice
  - Fix full screen monitor placement under wayland
  - Fix command line encoding on Windows
  - Ensure VM name is set in window title
  - Support unix-path in .vv files
  - Support text console windows via VTE
  - Add machine power control menu options
  - Record full build env in MSI installer

7.0: Jul 27, 2018
-----------------

  - Require spice-gtk >= 0.35
  - Clarify error message when no running VM is found
  - Improve check for libgovirt requirements
  - Support "-" as a URI for input connection file
  - Remove support for spice controller interface
  - Misc man page fixes
  - Lookup win32 translations relative to install dir
  - Position connect window in center not top-left
  - Misc fixes for ovirt foreign menu support

6.0: Aug 15, 2017
-----------------

  - Mention use of ssh-agent in man page
  - Display connection issue warnings in main window
  - Switch to GTask API
  - Add support changing CD ISO with oVirt foreign menu
  - Update various outdated links in README
  - Avoid printing password in debug logs
  - Pass hostname to authentication dialog
  - Fix example URLs in man page
  - Add args to virt-viewer to specify whether to
    resolve VM based on ID, UUID or name
  - Fix misc runtime warnings
  - Improve support for extracting listening info from XML
  - Enable connecting to SPICE over UNIX socket
  - Fix warnings with newer GCCs
  - Allow controlling zoom level with keypad
  - Don't close app during seemless migration
  - Don't show toolbar in kiosk mode
  - Re-show auth dialog in kiosk mode
  - Don't show error when cancelling auth
  - Change default screenshot name to 'Screenshot.png'
  - Report errors when saving screenshot
  - Fix build with latest glib-mkenums

5.0: Nov 24, 2016
-----------------

  - Don't retry authentication when credentials
    are provided via vvfile
  - Fix display of guest name in title for VNC
  - Fix detection of domain stop when tunnelling
    over SSH
  - Fix problem resizing with GTK client side
    decorations
  - Fix leak on file transfer
  - Only include native spec file in dist to fix
    rpmbuild -ta
  - Check min required spice-glib version
  - Display errors to user if failing to open UNIX socket
  - Simplify file transfer UI to only display overall
    progress, rather than full list of files
  - Show list of files which failed to transfer

4.0: Jun 20, 2016
-----------------

  - Drop support for gtk2 builds
  - Require spice-gtk >= 0.31
  - Require glib2 >= 2.38
  - Require gtk3 >= 3.10
  - Require libvirt-glib >= 0.1.8
  - Increase minimum window size fo 320x200 instead of 50x50
  - Remove use of GSLice
  - Don't show usbredir button if not connected yet
  - Only compute monitor mapping in full screen
  - Don't ignore usb-filter in spiec vv-file
  - Port to use GtkApplication API
  - Don't leave window open after connection failure
  - Validate symbols from max glib/gdk versions
  - Don't use GtkStock
  - Don't use gtk_widget-modify_{fg,bg} APIs
  - Drop use of built-in eventloop in favour of libvirt-glib
  - Don't open X display while parsing command line
  - Fix window title
  - Use GResource for building ui files into binary
  - Fix crash with invalid spice monitor mapping
  - Add dialog to show file transfer progress and allow
    cancelling
  - Remove unused nsis installer support
  - Include adwaita icon theme in msi builds
  - Add more menu mnemonics
  - Fix support for windows consoles to allow I/O redirection
  - Add support for ovirt sso-token in vv-file
  - Fix crash with zooming window while not connected
  - Remove custom auto drawer widget with GtkRevealer
  - Add appdata file for gnome software
  - Misc other bug fixes
  - Refresh translations

3.0: Dec 3, 2015
----------------

  - Last release to support GTK2 for Linux. The next
    4.0 release will be GTK3 only.
  - Don't add URI scheme / path info to oVirt URIs
  - Require spice-gtk >= 0.30
  - Enable webdav folder sharing with spice
  - Add preferences UI dialog
  - Take --direct into account when checking if guest is
    reachable
  - Take SPICE proxy into account when connecting to oVirt
    instances
  - Fail gracefully when hostname is not returned by
    oVirt
  - Don't show empty foreign menu on secondary displays
  - Avoid accidentally trying to connect to port 0 when
    oVirt doesn't specify a port number
  - Correctly update geometry when enabling/disabling
    display heads
  - Avoid accidentally creating extra monitors when using
    configuration file monitor mapping
  - Exit normally when cancelling connect dialog
  - Don't wait for a guest that we know will never show up
  - Fix crash when using --reconnect with SPICE
  - Avoid zooming out if it would decrease window size
    below minimum required for top menu display
  - Fix crash when disabling last enabled display
  - Honour changes in display position from guest
  - Don't show error dialog twice for unknown graphics type
  - Allow to cancel oVirt auth without error
  - Set sensitivity of display menu based on whether it is
    usable or not
  - Set sensitivity of tool bar buttons based on whether they
    are usable or not
  - Set guest name reported by VNC
  - Fix crash when using gtk-vnc 0.3.8
  - Fix alt-tab behaviour in choose VM dialog
  - Don't allow missing display in monitor mapping config
  - Add --with-osid flag to configure to allow specifying
    the operating system build target. The values should
    be based on libosinfo OS short IDs.
  - Ensure windows installer places menu icon for all users
    not just admin. Requires manual uninstall of previous
    windows version
  - Require address in remote viewer connect dialog
  - Automatically retry VNC connection after auth failure
  - Drop GTK2 support for Windows builds
  - Enable keepalives on libvirt conncetion
  - Allow resize of window to arbitrary size
  - Fix thread safety handling event callbacks
  - Avoid deprecation warnings with newer glib
  - Pulled in multiple fixes for event loop from libvirt-glib
  - Fix misc bugs reported by coverity
  - Fix binary ID in MSI installer
  - Stop polling libvirt after reconnceting to libvirt

2.0: Jan 12, 2015
-----------------

  - Fix handling of zoom in/out accelerators
  - Fix warning going in/out of fullscreen
  - Add dialog showing info about the current guest
  - Change format of fullscreen config setting to
    allow for sparse guest displays
  - Write VM name to config file as a comment
  - Never use fallback CA certs when loading vv-file
  - Remove extraneous '/' from oVirt URIs
  - Support oVirt foreign menus
  - Allow using numapad for zoom in/out accelerators
  - Force geometry update when agent connects
  - Fix misc crash bugs
  - Fix misc memory leaks
  - Allow viewing of password entry characters
  - Don't fail when auth dialog is cancelled
  - Only create extra windows on demand
  - Use more sensible default window size
  - Improve docs for URIs and config files
  - Allow cancellation of SPICE auth dialog
  - Use new libvirt API for --attach to avoid SELinux AVC
  - Allow removable of CD images with oVirt connections
  - Show VM choose dialog when oVirt VM name is missing
  - Support usernames request with SASL auth
  - Use socat instead of nc if available
  - Use PNG instead of SVG for icons
  - Support connection to UNIX sockets instead of TCP
  - Honour zoom level from CLI args with VNC
  - Switch to GTK3 instead of GKT2 for Windows builds
  - Ensure dialogs have transient parent set
  - Switch to gstreamer 1.0 instead of 0.10 for Windows builds
  - Avoid accidentally connecting to localhost with VNC/SPICE
  - Use a versioned install directory for Windows builds

1.0: Jul 21, 2014
-----------------

  - Switched to 2-digit version numbering.
  - Improve error reporting when failing to find
    the GtkBuilder UI files
  - Honour title provided by SPICE server if available
  - Don't hide main window when disconnecting in multi-monitor
    configurations
  - Don't show VNC widget until authentication has completed
  - Fix session handling when re-authenticating
  - Improve docs for --attach flag
  - Ask for credentials for SPICE proxy
  - Fix scaling of windows when resizing
  - Remove 'Automatically resize' menu, leaving the behaviour
    permanently enabled
  - Improve USB icon in full screen toolbar
  - Don't resize guest when changing zoom level
  - Don't create windows at startup if kiosk mode isn't enabled
  - Don't show quit confirmation dialog in kiosk mode
  - Misc typos / fixes in man pages
  - Fix race with metacity window manager in fullscreen mode
  - Avoid accidentally connecting to localhost with --direct flag
  - Use custom log handler to silence debug messages on old glib2
  - Fix tiny windows for secondary displays with gtk2 build
  - Take zoom into account when checkign display limits
  - Fix unshrinkable displays with windows guests
  - Allow  ctrl-[+-] to zoom in fullscreen mode

0.6.0: Jan 24, 2014
-------------------

  - Require govirt 0.3.0
  - Require spice-gtk 0.22
  - Show error dialog if password is wrong
  - Document application/x-virt-viewer file format
  - Remove unused '-d' option from remote-viewer
  - Add a kiosk mode
  - Add menu for sending Ctrl+Alt+Delete
  - Add Ctrl+Alt+End as accelerator for Ctrl+Alt+Delete
  - Send modifiers before the non-modifier key in send
    key menu
  - Fix GTK warning when disconnecting from VNC due to
    auth error
  - Make 'Cancel' default button in exit dialog
  - Make send key menu accelerators work in fullscreen
  - Remove insecure fetching of oVirt CA cert
  - Build for GTK 3 by default
  - Fix title bar after failed connection
  - Reshow remote-viewer connection dialog upon error
  - Hide all windows upon disconnect
  - Add ability to define custom monitor mapping
  - Ensure all windows obey command line zoom level
  - Add an icon to the desktop file
  - Fix event loop implementation on Win32 platforms
  - Misc other bug fixes

0.5.7: Jul 31, 2013
-------------------

  - Many fixes to full screen / window positioning handling
  - Reshow connect dialog if connection fails
  - Misc man page fixes
  - Mark RPM as obsoleting spice-client
  - Set the host subject to fix SSL connections with ovirt
  - Use -H as short variant of --hotkeys
  - Add missing trailing ';' in desktop file
  - Allow TLS only SPICE connections
  - Use dynamic key send menu
  - Enable smartcard shortcuts only when smartcard reader is present
  - Misc other bug fixes

0.5.6: Apr 12, 2013
-------------------

  - Add ovirt:// support to remote-viewer (needs libgovirt)
  - Many fullscreen and multi-monitor fixes
  - Add a minimum version check in connection file
  - Fix sending key combinations from "Send Key" menu when the key names are
    localized
  - Fix build with older glib and gtk+
  - Fix MSI x64 build
  - Clean-ups (remove browser plugin entirely)

0.5.5: Feb 13, 2013
-------------------

  - Improve screenshot saving dialog
  - remote-viewer learned to connect with a file of mime type
    application/x-virt-viewer, described in src/virt-viewer-file.c
  - Add a "do not ask me again" dialog checkbox when leaving
  - Add a MSI target, using https://live.gnome.org/msitools
  - Add windows debug helper, useful in Spice controller running context
  - Add remote-viewer --title STRING
  - Support for Spice proxy settings added
  - Numerous Spice display and multi-monitor fixes
  - win32, memory, build, and other misc fixes
  - Requires spice-gtk >= 0.16.26

0.5.4: Sep 17, 2012
-------------------

  - Fix host migration with Spice
  - Fix misc memory leaks
  - Fix build with newer glibc and -O0
  - Improve automatic fullscreen Spice configuration
  - Avoid crash when quiting application
  - Rebuild display men whenever a window is added/removed
  - Number displays starting from 1 instead of 0
  - Add support for handling multiple monitors with Spice
  - Menu display menu insensitive if no displays can be selected
  - Use real binary name in remote-viewer help message
  - Document -f=auto-conf in remote-viewer help

0.5.3: May 14, 2012
-------------------

  - Add support for raw IPv6 addresses
  - Add a remote-viewer.desktop file and register spice:// handling
  - Add a simple connection dialog to remote-viewer
  - Add remote-viewer --fullscreen=auto-conf option, to update guest
    monitors configuration to match client
  - Spice controller support for disable-effects, color-depth and
    usbredir
  - Spice controller interaction fixes
  - Windows version and nsis installer improvements
  - Import newer translations from transifex
  - Misc reference leak / crash bugs fixed


0.5.2: Mar 09, 2012
-------------------

  - Require libvirt >= 0.9.7, spice-gtk >= 0.11, spice-protocol >= 0.10.1
  - Import newer translations from transifex
  - remote-viewer learned Spice controller customizable key bindings,
    smartcard property, and foreign menu
  - Fix Spice crash on re-connection
  - Fix connecting via ssh to a password-protected server
  - Add a sendkey menu in fullscreen mode
  - Add USB device selection in fullscreen mode
  - Misc reference leak / crash bugs fixed

0.5.1: Feb 17, 2012
-------------------

  - Import newer translations from transifex
  - Fix build system to ensure we don't loose GNU_RELRO
    security feature
  - Don't link virt-viewer binary against spice controller
  - Add back compat for GObject 2.22 which lacks GBinding

0.5.0: Feb 14, 2012
-------------------

  - Add a remote-viewer binary for connecting to a SPICE/VNC
    server based on URI, instead of querying libvirt
  - Add ability to attach to a local VM via libvirt instead of
    connecting over UNIX sockets
  - Add support for SPICE controller
  - Allow build without libvirt, for remote-viewer only
  - Automatically resize guest desktop when resizing window with SPICE
  - Add support for redirecting host USB devices to remote guest
  - Grab focus when first showing the display
  - Register as a spice-xpi-client-remote alternative
  - Add pretty icon for virt-viewer app
  - Set transient window hints on all popups
  - Activate password 'Ok' button when pressing Enter
  - Support secure connections with SPICE
  - Don't hardcode 'localhost' for hostname

0.4.2: Nov  9, 2011
-------------------

  - Fix exports of signal functions for GTK UI builder on Windows
  - Avoid crash if xmlParseURI fails
  - Fix inverted test for SSH port that broke tunnelling
  - Don't hardcode port numbers for SSH if not requested by user
  - Fix deadlock in event handling
  - Fix initial zoom level for all windows
  - Fix window title to include domain name
  - Fix hostname used when XML gives a wildcard IP address
  - Fix window title when waiting for domain to appear
  - Fix key shortcust for F9-F12 menus
  - Always ask libvirt for its canonical URI
  - Allow build without GTK-VNC (ie spice only)
  - Require GTK-VNC >= 0.4.3
  - Require SPICE-GTK >= 0.6.0


0.4.1: Aug  4, 2011
-------------------

  - Remove bogus use of AM_GLIB_GNU_GETTEXT macro to try to
    facilitate BSD builds
  - Support multiple monitors with SPICE and QXL drivers
  - Don't hardcode SSH port to 22 when tunnelling

0.4.0: Jul 12, 2011
-------------------

  - Require SPICE-GTK >= 0.6
  - Hide menu bar when going fullscreen
  - Support building against GTK2 or GTK3
  - Convert from Glade to GtkBuilder
  - Honour 'listen' attribute from <graphics> XML when connecting
  - Fix reconnection after authentication failure
  - Make --verbose flag actually do something
  - Enable scaling with SPICE to match VNC behaviour
  - Rewrite widget resizing code to (try to) be more reliable
  - Fill extra space outside guest display with black
  - Fix (null) in title bar while not connected
  - Fix multiple memory leaks
  - Fix reconnecting to display with SPICE

0.3.1: Feb 21, 2011
-------------------

  - Fix typo in configure script that broke SPICE

0.3.0: Feb 21, 2011
-------------------

  - Add support for SPICE graphics client
  - Allow connections to VNC server over UNIX sockets
  - Improve error messages on auth/connection failure
  - Add support for zoom levels
  - Many updated translations

0.2.1: Jan 15, 2010
-------------------

  - Add infrastructure for translation
  - Display dialog to user if authentication fails
  - Display dialog to user if domain cannot be found
  - GTK/GLib best practice cleanups
  - Add Polish translation

0.2.0: July 20, 2009
--------------------

  - Switch UI over to use Glade
  - Support graphical dialog for VNC and libvirt authentication
  - Resize window to match VNC desktop size where possible
  - Scale down VNC desktop if it cannot fit in host desktop space
  - Allow user to resize window to arbitrary size, scaling VNC
  - Fix blocking of accelerators
  - Allow automatic reconnect to a VM via --reconnect
  - Use libvirt events to detect when VM changes state
  - Wait for VM to appear if it does not exist
  - Fix plugin build with newer xulrunner
  - Port & build for Mingw32 target

0.0.3: March 10, 2008
---------------------

  - Block accelerators when grab is active
  - Enable smooth scaling of desktop to fill screen
  - Added an experimental firefox plugin (disabled by default)
  - Hide characters in password entry field
  - Use domain name in title bar instead of VNC desktop name

0.0.2: August 28, 2007
----------------------

  - Support connecting to remote libvirt servers
  - Support connecting to remote VNC consoles
  - Support tunneling VNC over SSH
  - Support TLS x509 certificate credentials

0.0.1: August 15, 2007
----------------------

  - Initial release
